#ifndef VNCRYPT_H
#define VNCRYPT_H

/* $Id: vn_crypt.h,v 1.7 2002/02/25 22:47:23 rblaze Exp $ */

#include <sys/queue.h>

#define VNIOCCRYPT	_IOWR('F', 6, void **)  /* enable crypto */

#define VNCRYPT_TO_NONE 0
#define VNCRYPT_TO_DETACH   1

#define VNCRYPT_BF_CBC_ID 1
#define VNCRYPT_AES_CBC_ID 2
#define VNCRYPT_AES_MULTI_ID 3


struct vncr_generic_params {
	int vncr_algid;
	int vncr_timeout_action;
	long vncr_timeout;
};

#ifdef _KERNEL

typedef void *vncr_create_context_t(const void *);
typedef void  vncr_delete_context_t(void *);
typedef void  vncr_process_block_t(void *, daddr_t, void *, size_t);

struct vncr_alg_info {
	int alg_id;
	vncr_create_context_t *alg_create_ctx;
	vncr_delete_context_t *alg_delete_ctx;
	vncr_process_block_t *alg_encrypt;
	vncr_process_block_t *alg_decrypt;
	LIST_ENTRY(vncr_alg_info) chain;
};

/*     */
int vncrypt_register_alg(struct vncr_alg_info *);
int vncrypt_unregister_alg(int);

/*     */
int vncrypt_enable(const void *, void **);
void vncrypt_delete(void *);
void vncrypt_encrypt_block(void *, daddr_t, void *, size_t);
void vncrypt_decrypt_block(void *, daddr_t, void *, size_t);

int vncrypt_check(void *);

#endif

#endif
